static char sccs_xexterns_h[] = "@(#)xexterns.h	1.1 10/16/90 11:03:08 LLNL ";
#include <X11/X.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#ifdef X11R3
#include <X11/Form.h>
#include <X11/Label.h>
#include <X11/Command.h>
#include <X11/AsciiText.h>
#include <X11/VPaned.h>
#include <X11/Box.h>
#include <X11/Viewport.h>
#include <X11/Dialog.h>
#include <X11/List.h>
#else
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/VPaned.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/List.h>
#endif



/*
 * Copyright Cray Research, Inc.  Unpublished.	All rights reserved.

 * Cray Research warrants and provides support for this software
 * only when distributed and used under the terms of a license
 * agreement with Cray Research.

 * FOR PRODUCT DISTRIBUTED IN ANY OTHER MANNER, CRAY RESEARCH DISCLAIMS
 * ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS.  IN NO EVENT SHALL 
 * CRAY RESEARCH BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA
 * OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OF
 * THIS SOFTWARE.
*/

#define BUFFER_LENGTH 5120
#define maxArgs 10

extern Widget frame;	      /* the main widget opened to X11 */
extern Widget panel;	      /* this panel contains all the other widgets */
extern Widget control_widget; /* the upper left control window */
extern Widget message_widget; /* the upper right text (message) window */
extern Widget outer_canvas;   /* outer window to the viewport canvas widget */
extern Widget inner_canvas;   /* inner window to the viewport canvas widget */
extern Widget news_widget;    /* text widget for the news */
extern Widget outer_hist;     /* outer window to viewport histogram widget */
extern Widget inner_hist;     /* inner window to the viewport histogram wid */
extern Widget hist_viewport;  /* histogram viewport widget */
extern Widget hist_shell;     /* histogram shell declaration for popup */
extern Widget filter_shell;   /* filter shell declaration for popup */
extern Widget title;	      /* "GMAT - timeline"  title line */
extern Widget hidden_canvas;  /* window where process icons are displayed */
extern Widget jump_button;    /* jump command button */
extern Widget jump_execute_button; /* execute jump command button */
extern Widget jump_cancel_button;  /* cancel jump request command button */
extern Widget interval_choice;	   /* clock interval command button */
extern Widget interval_shell;	/* interval popup shell */
extern Widget idle_choice;    /* idle interval command button */
extern Widget idle_shell;     /* idle popup shell */
extern Widget filter_button;	 /* filter command button */
extern Widget address_choice; /* button for selecting lock, bar, or events */
extern Widget address_pop;    /* address popup menu selection box */
extern Widget dir_label;      /* directory label widget (not the command) */
extern Widget trace_label;    /* trace file label widget (not the command) */
extern Widget idle_label;     /* idle label widget (not the command) */
extern Widget filter_label;   /* filter label widget (not the command) */
extern Widget clock_label;    /* clock label widget (not the command) */
extern Widget machine_label;  /* machine label widget (not the command) */
extern Widget address_label;  /* address label widget (not the command) */
extern Widget jump_label;     /* jump label widget (not the command) */
extern Widget file_choice;    /* command button for selection trace file */
extern Widget directory_choice;	 /* command button for selecting directory */
extern Widget machine_choice; /* command button for selecting machine type */
extern Widget machine_shell;   /* machine popup shell */
extern Widget dir_pop;	      /* directory popup menu selection box */
extern Widget jump_pop;	      /* jump popup menu selection box */
extern Widget file_pop;	      /* trace file popup menu selection box */
extern Widget speedometer_label; /* warp factor label widget */
extern Widget dir_shell;      /* directory shell declaration for popup */
extern Widget jump_shell;     /* jump shell declaration for popup */
extern Widget file_shell;     /* trace file shell declaration for popup */
extern Widget jumpby_choice;  /* button for selection how to jump */
extern Widget jumpDirection_choice;   /* button for selection how to jump */
extern Widget key_pop;	      /* key popup box */
extern Widget key_shell;      /* key shell declaration for popup */
extern Widget address_shell;  /* address shell declaration for popup */
extern Widget jumpto_value;   /* ascii jump to value from dialogWidget */
extern Widget jumpby_buttons; /* jump selection table */
extern Widget jump_direction_buttons; /* jump selection table */
extern Widget jumpby_shell;   /* shell declaration for jumpby_buttons */
extern Widget jumpby_pop;    
extern Widget jump_direction_shell;	 /* jump shell declaration for popup */
extern Widget jump_direction_pop;/* jump direction popup menu selection box */
extern Widget jump_pop;	      /* jump popup menu selection box */
extern Widget news_widget;    /* news widget -asciiDiskWidget */
extern Widget news_shell;     /* news popup shell */
extern Widget news_pop;	      /* news popup widget */
extern Widget action_shell;   /* action popup shell */
extern Widget action_pop;     /* action popup widget */

extern Screen *hidden_scr;    /* screen definition for the hidden screen */
extern Screen *canvas_screen; /* screen definition for the canvas screen */
extern Screen *control_screen;/* screen definition for the control screen */
extern Screen *hist_screen;   /* screen definition for the histogram screen */
extern Screen *key_scr;	      /* screen definition for the popup key */

extern Display *display_control; /* display for communication with manager */
extern Display *hidden_display;	 /* display definition:	 == display_control */
extern Display *canvas_display;	 /* display definition:	 == display_control */
extern Display *control_display; /* display definition:	 == display_control */
extern Display *hist_display;	 /* display definition:	 == display_control */
extern Display *text_display;	 /* display definition:	 == display_control */
extern Display *key_display;	 /* display definition:	 == display_control */

extern Window can_win;	      /* window definition for the canvas window */
extern Window hidden_win;     /* window definition for the hidden window */
extern Window control_win;    /* window definition for the control window */
extern Window hist_win;	      /* window definition for the histogram window */
extern Window text_win;	      /* window definition for the text window */
extern Window key_win;	      /* window definition for the key window */
extern Window frame_wid;	      /* window definition for the key window */

extern GC control_gc;	      /* graphics control for writing to control win. */
extern GC event_gc;		  /* graphics control for writing to event boxes. */
extern GC canvas_gc;	      /* graphics control for writing to canvas win. */
extern GC hidden_gc;	      /* graphics control for writing to hidden win. */
extern GC key_gc;		  /* graphics control for writing to key win. */
extern GC dotted_gc;	      /* graphics control for drawing wait line */
extern GC dotted_line_gc;     /* graphics control for drawing wait line */

extern XWindowAttributes frameAttributes;
extern Arg args[];

extern int move_height;	      /* used to manage scrolling of canvas widget */
extern int move_hist;	      /* used to manage scrolling of historgram widget*/
extern char *interval_table[];/* string table of intervals selections*/
extern char *idle_table[];    /* string table of idle selections*/
extern char *machine_table[]; /* string table of machine selections*/
extern char *address_table[]; /* string table of address selections */
extern char *jumpby_table[];  /* string table of jump by selections */
extern char *jump_direction_table[];  /* string table of jump by selections */
extern char *filter_table[];  /* string table of filter selections*/
extern caddr_t event_count;

extern XtActionProc fileMenu();
extern XtActionProc dirMenu();
extern void file_notify_proc();
extern void directory_notify_proc();
extern XtCallbackProc popAddress();
extern void set_jump_selection();

extern Pixel black;
extern Pixel white;
extern int rv;
extern unsigned int depth;
